/*
dcl.h e' un modulo header che insieme a dcl.c fornisce l'implementazione 
di 3 nuovi tipi:
	ide, num, dcl
I tipi ide e num possono essere direttamente implementati con i tipi string
e int, in analogia a quanto fatto in laboratorio utilizzando Ocaml, come
linguaggio di sviluppo.
Il tipo dcl introduce alberi astratti per dichiarazioni di SmallC. Questo 
tipo deve contenere 6 distinti tipi di alberi che utilizzando i tipi alge-
brici di Ocaml abbiamo cosi espresso in Ocaml (vedi laboratorio): omissis
 */

//dichiarazioni per implementare ide e num:
typedef char * ide;
typedef int num;

//Strutture per rappresentare dcl

struct Const{
    ide name; 
    num val;
} ctr;

struct Var{
    ide name; 
    num val;
} var;

struct Var1{
    ide name; 
} var1;
 
struct Array{
    ide name;
	num size;
} array;
 
struct SeqD{
	struct dclElem * X;
	struct dclElem * Y;
}seqD;
 
union DclUnion{
	struct Const C;
	struct Var V;
	struct Var1 N;
	struct Array A;
	struct SeqD S;
} dclUnion;
 
typedef enum{Const, Var, Var1, Array, SeqD} DclKind;

typedef struct DclElem{
	DclKind flag;
	union DclUnion d;
} dclElem;

typedef dclElem * dcl;

//Le operazioni su Dcl: 
// mkConst, mkVar, mkVar1, mkArray, mkSeqD, isConst, isVar, isVar1, 
// isArray, isSeqD, printDcl, getIde, getVal, getDclL, getDclR

typedef enum {false,true} bool;

dcl mkConst(ide i, num v);
dcl mkVar(ide i, num v);
dcl mkVar1(ide i);
dcl mkArray(ide i, num s);
dcl mkSeqD(dcl l, dcl r);
bool isConst(dcl d);
bool isVar(dcl d);
bool isVar1(dcl d);
bool isArray(dcl d);
bool isSeqD(dcl d);
void printDcl(dcl d);
ide getIde(dcl d);
num getVal(dcl d);
dcl getDclL(dcl d);
dcl getDclR(dcl d); 





